<?php

class ModelPaymentEcommpay extends Model
{
    const
        STATUS_SUCCESS = 'success',
        STATUS_DECLINE = 'decline',
        STATUS_REFUNDED = 'refunded',
        STATUS_REVERSED = 'reversed';

    public function getMethod($address, $total)
    {
        $this->load->language('payment/ecommpay');

        $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" .
            (int)$this->config->get('ecommpay_geo_zone_id') . "' AND country_id = '" .
            (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] .
            "' OR zone_id = '0')");

        if (!$this->config->get('ecommpay_geo_zone_id')) {
            $status = true;
        } elseif ($query->num_rows) {
            $status = true;
        } else {
            $status = false;
        }

        if (!$status) {
            return [];
        }

        return [
            'code' => 'ecommpay',
            'title' => $this->config->get('ecommpay_title'),
            'terms' => $this->config->get('ecommpay_description'),
            'sort_order' => $this->config->get('ecommpay_sort_order')
        ];
    }

    public function resolveStatus($ecpStatus)
    {
        switch ($ecpStatus) {
            case self::STATUS_SUCCESS:
                return $this->config->get('ecommpay_success_status');

            case self::STATUS_DECLINE:
                return $this->config->get('ecommpay_failed_status');

            case self::STATUS_REFUNDED:
                return $this->config->get('ecommpay_refunded_status');

            case self::STATUS_REVERSED:
                return $this->config->get('ecommpay_reversed_status');

            default:
                return $this->config->get('ecommpay_pending_status');
        }
    }
}

?>